Imports System.Drawing.Imaging

Public Class Form1


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        MyTabControl1.SelectedIndex = 4

        ComboBox_Language.SelectedIndex = 0
        MyComboBox1.SelectedIndex = 0
        MyComboBox2.SelectedIndex = 0
        MyComboBox3.SelectedIndex = 0
        MyComboBox4.SelectedIndex = 0
        MyComboBox5.SelectedIndex = 0
        MyComboBox6.SelectedIndex = 0
        MyComboBox7.SelectedIndex = 0
        MyComboBox8.SelectedIndex = 0
        cmb_Bins.SelectedIndex = 2
        cmb_Sampling.SelectedIndex = 2
        cmb_PulsePolarity.SelectedIndex = 2

        ' -------------------------------------------------- MyListView - Flicker test
        ListView_Init()
        Timer1.Interval = 50
        Timer1.Start()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ListView_Update()
    End Sub


    Private Sub MyButtonON_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButtonON.ClickButtonArea
        With MyButtonON
            If .Text = "On" Then
                .ColorFillSolid = Color.Red
                .Text = "Off"
            Else
                .ColorFillSolid = Color.Green
                .Text = "On"
            End If
        End With
    End Sub

    Private Sub MyButtonGDExit_ClickButtonArea(ByVal Sender As Object, ByVal e As System.EventArgs) Handles MyButtonGDExit.ClickButtonArea
        Me.Close()
    End Sub

    Private Sub MyButtonMoveUp_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButtonMoveUp.AutoRepeatClick
        Dim y As Integer = lblMove.Location.Y - 4
        If y < 0 Then y = 0
        lblMove.Location = New Size(lblMove.Location.X, y)
    End Sub
    Private Sub MyButtonMoveDn_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButtonMoveDn.AutoRepeatClick
        Dim y As Integer = lblMove.Location.Y + 4
        If y > 100 - lblMove.Height Then y = 100 - lblMove.Height
        lblMove.Location = New Size(lblMove.Location.X, y)
    End Sub
    Private Sub MyButtonMoveRight_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButtonMoveRight.AutoRepeatClick
        Dim x As Integer = lblMove.Location.X + 4
        If x > 100 - lblMove.Width Then x = 100 - lblMove.Width
        lblMove.Location = New Size(x, lblMove.Location.Y)
    End Sub
    Private Sub MyButtonMoveLeft_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButtonMoveLeft.AutoRepeatClick
        Dim x As Integer = lblMove.Location.X - 4
        If x < 0 Then x = 0
        lblMove.Location = New Size(x, lblMove.Location.Y)
    End Sub
    Private Sub MyButtonMoveCenter_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButtonMoveCenter.ClickButtonArea
        lblMove.Location = New Size((100 - lblMove.Width) / 2, (92 - lblMove.Height) / 2)
    End Sub

    Private Sub chkPanelBack_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkPanelBack.CheckedChanged
        For Each c As Control In TabPage2.Controls
            If Not c Is sender Then
                c.Enabled = sender.Checked
            End If
        Next
    End Sub
    Private Sub chkEnabledExamples_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkEnabledExamples.CheckedChanged
        For Each c As Control In TabPage4.Controls
            If Not c Is sender Then
                c.Enabled = sender.Checked
            End If
        Next
    End Sub
    Private Sub CheckBox_EnableTextBoxes_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_EnableTextBoxes.CheckedChanged
        For Each c As Control In TabPage7.Controls
            If Not c Is sender Then
                c.Enabled = sender.Checked
            End If
        Next
    End Sub








    ' -------------------------------------------------- MyListView - Flicker test
    Friend Sub ListView_Init()
        With MyListView1
            .GridLines = True
            .Header_BackColor1 = Color.FromArgb(255, 255, 200)
            .Header_BackColor2 = Color.FromArgb(200, 200, 200)
            .Header_ForeColor = Color.FromArgb(100, 80, 0)
            .Header_ShadowColor = Color.FromArgb(120, 120, 120)
            .Header_Font = New Font("Tahoma", 10, FontStyle.Regular)
            .Font = New Font("Courier new", 9)
            .View = View.Details
            .SetExtStyle_DoubleBuffering()
            .Clear()
            ' ----------------------------------------------------------------- column headers
            .Columns.Add("Type", 60, HorizontalAlignment.Left)
            .Columns.Add("Subtype", 90, HorizontalAlignment.Left)
            .Columns.Add("Value", 70, HorizontalAlignment.Right)
            '
            For n As Int32 = 0 To 12
                Dim item As ListViewItem = .Items.Add("")
                item.SubItems.Add("")
                item.SubItems.Add("")
            Next
            .EndUpdate()
        End With
    End Sub

    Friend Sub ListView_Update()
        With MyListView1
            .SetExtStyle_DoubleBuffering()
            .BeginUpdate()
            For n As Int32 = 0 To 12
                .Items(n).Text = "Line"
                .Items(n).SubItems(1).Text = n.ToString
            Next
            .EndUpdate()
        End With
    End Sub



    ' ############################################################################################################
    '  TODO - Using style WS_EX_COMPOSITED
    '   not working with MyTextBox with BackColorOver ( use Transparent )
    ' ############################################################################################################

    ' ============================================================================================================
    '   PREVENT FORM FLICKERING -  With style WS_EX_COMPOSITED
    '   With that style turned on, Windows XP does double-buffering on the form and all its child controls. 
    ' ============================================================================================================
    'Protected Overrides ReadOnly Property CreateParams() As CreateParams
    '    Get
    '        Dim cp As CreateParams = MyBase.CreateParams
    '        cp.ExStyle = cp.ExStyle Or 33554432
    '        Return cp
    '    End Get
    'End Property
    ' ============================================================================================================



    ' ==================================================================================================
    '  SAVE IMAGE
    ' ==================================================================================================
    Private Sub Button_SaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_SaveImage.Click
        SaveImage("TestImage", Me)

    End Sub

    Public Sub SaveImage(ByVal img As Image, _
                         ByVal filename As String, _
                         ByVal extension As String, _
                         ByVal Quality As Int32)

        extension = LCase(extension)
        filename = RemoveExtension(filename)
        filename += "." & extension
        '
        If img Is Nothing Then Return
        Try
            File_Kill(filename)
            If extension = "jpg" Then
                Dim ImageEncoders() As ImageCodecInfo = ImageCodecInfo.GetImageEncoders()
                Dim myEncoder As System.Drawing.Imaging.Encoder = System.Drawing.Imaging.Encoder.Quality
                Dim myEncoderParameters As New EncoderParameters(1)
                Dim myEncoderParameter As New EncoderParameter(myEncoder, 100)
                myEncoderParameters.Param(0) = myEncoderParameter
                img.Save(filename, ImageEncoders(1), myEncoderParameters)
            Else
                img.Save(filename, ImageFormatFromFileExtension(extension))
            End If


            Process.Start(filename)
        Catch
            MsgBox("Image save error", MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Function ImageFormatFromFileExtension(ByVal extension As String) As ImageFormat
        Select Case LCase(extension)
            Case "jpg" : Return ImageFormat.Jpeg
            Case "png" : Return ImageFormat.Png
            Case "tiff" : Return ImageFormat.Tiff
            Case "exif" : Return ImageFormat.Exif
            Case "emf" : Return ImageFormat.Emf
            Case "wmf" : Return ImageFormat.Wmf
            Case "gif" : Return ImageFormat.Gif
            Case "bmp" : Return ImageFormat.Bmp
                'Case "ico" : Return ImageFormat.Icon
            Case Else : Return ImageFormat.Jpeg
        End Select
    End Function

    Friend Sub File_Kill(ByVal filename As String)
        If My.Computer.FileSystem.FileExists(filename) Then
            My.Computer.FileSystem.DeleteFile(filename, FileIO.UIOption.OnlyErrorDialogs, FileIO.RecycleOption.DeletePermanently)
        End If
    End Sub

    Friend Sub SaveImage(ByVal Prefix As String, ByVal cnt As Control)
        Dim img As Image = GetImage(cnt)
        Dim sfd As SaveFileDialog = New SaveFileDialog()
        sfd.Filter = "Portable network graphics (*.png)|*png|JPEG image (*.jpg)|*.jpg"
        sfd.FileName = Prefix '& Date.Now.ToString("yyyy_MM_dd_HH_mm_ss")
        If sfd.ShowDialog() = Windows.Forms.DialogResult.OK Then
            SaveImage(img, sfd.FileName, If(sfd.FilterIndex = 2, "jpg", "png"), 100)
        End If
    End Sub
    Friend Function GetImage(ByVal cnt As Control) As Bitmap
        Dim s As Size = cnt.Size
        Dim bmp As Bitmap = New Bitmap(s.Width, s.Height)
        cnt.DrawToBitmap(bmp, New Rectangle(0, 0, s.Width, s.Height))
        Return bmp
    End Function
    Public Function RemoveExtension(ByVal str As String) As String
        On Error Resume Next
        Return IO.Path.GetDirectoryName(str) & "\" & IO.Path.GetFileNameWithoutExtension(str)
    End Function

    Private Sub cmb_PulsePolarity_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_PulsePolarity.DropDown
        cmb_PulsePolarity.ItemHeight = 16
    End Sub

End Class
